Hex Artifact Content

Artifact d401f36a65235788feb2bf0b52aedeac19a23731:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 65 74 65 72 6d 69 6e 65 4f 73 41 72 63  n determineOsArc
0130: 68 28 29 20 7b 0a 09 6f 73 3d 22 24 28 75 6e 61  h() {..os="$(una
0140: 6d 65 20 2d 73 20 7c 20 64 64 20 63 6f 6e 76 3d  me -s | dd conv=
0150: 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f 6e 75 6c  lcase 2>/dev/nul
0160: 6c 29 22 0a 09 61 72 63 68 3d 22 24 28 75 6e 61  l)"..arch="$(una
0170: 6d 65 20 2d 6d 20 7c 20 64 64 20 63 6f 6e 76 3d  me -m | dd conv=
0180: 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f 6e 75 6c  lcase 2>/dev/nul
0190: 6c 29 22 0a 0a 09 63 61 73 65 20 22 24 7b 61 72  l)"...case "${ar
01a0: 63 68 7d 22 20 69 6e 0a 09 09 69 3f 38 36 29 0a  ch}" in...i?86).
01b0: 09 09 09 61 72 63 68 3d 27 69 78 38 36 27 0a 09  ...arch='ix86'..
01c0: 09 09 3b 3b 0a 09 65 73 61 63 0a 7d 0a 0a 66 75  ..;;..esac.}..fu
01d0: 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65  nction determine
01e0: 50 72 65 66 69 78 28 29 20 7b 0a 09 64 65 74 65  Prefix() {..dete
01f0: 72 6d 69 6e 65 4f 73 41 72 63 68 0a 0a 09 70 72  rmineOsArch...pr
0200: 65 66 69 78 73 75 66 66 69 78 3d 22 24 7b 70 6b  efixsuffix="${pk
0210: 67 7d 2f 24 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d  g}/${os}-${arch}
0220: 2f 24 7b 76 65 72 73 69 6f 6e 7d 22 0a 09 70 72  /${version}"..pr
0230: 65 66 69 78 3d 22 2f 6f 70 74 2f 61 70 70 66 73  efix="/opt/appfs
0240: 2f 24 7b 64 6f 6d 61 69 6e 7d 2f 24 7b 70 72 65  /${domain}/${pre
0250: 66 69 78 73 75 66 66 69 78 7d 22 0a 09 64 65 73  fixsuffix}"..des
0260: 74 64 69 72 3d 22 24 28 70 77 64 29 2f 49 4e 53  tdir="$(pwd)/INS
0270: 54 22 0a 0a 09 6d 6b 64 69 72 20 22 24 7b 64 65  T"...mkdir "${de
0280: 73 74 64 69 72 7d 22 20 7c 7c 20 64 69 65 0a 7d  stdir}" || die.}
0290: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 63 6f  ..function preco
02a0: 6e 66 69 67 75 72 65 28 29 20 7b 0a 09 3a 0a 7d  nfigure() {..:.}
02b0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74 63  ..function postc
02c0: 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09 3a 0a  onfigure() {..:.
02d0: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6f 6e 66  }..function conf
02e0: 69 67 75 72 65 28 29 20 7b 0a 09 67 6c 69 62 63  igure() {..glibc
02f0: 76 65 72 73 3d 32 2e 32 30 0a 09 67 6c 69 62 63  vers=2.20..glibc
0300: 64 69 72 3d 22 2f 6f 70 74 2f 61 70 70 66 73 2f  dir="/opt/appfs/
0310: 63 6f 72 65 2e 61 70 70 66 73 2e 72 6b 65 65 6e  core.appfs.rkeen
0320: 65 2e 6f 72 67 2f 67 6c 69 62 63 2f 70 6c 61 74  e.org/glibc/plat
0330: 66 6f 72 6d 2f 24 7b 67 6c 69 62 63 76 65 72 73  form/${glibcvers
0340: 7d 22 0a 09 64 79 6e 6c 69 6e 6b 65 72 3d 22 24  }"..dynlinker="$
0350: 28 6c 73 20 22 24 7b 67 6c 69 62 63 64 69 72 7d  (ls "${glibcdir}
0360: 22 2f 6c 69 62 2f 6c 64 2d 6c 69 6e 75 78 2a 2e  "/lib/ld-linux*.
0370: 73 6f 2e 2a 20 7c 20 74 61 69 6c 20 2d 6e 20 31  so.* | tail -n 1
0380: 29 22 0a 0a 09 69 66 20 5b 20 21 20 2d 64 20 22  )"...if [ ! -d "
0390: 24 7b 67 6c 69 62 63 64 69 72 7d 22 20 5d 3b 20  ${glibcdir}" ]; 
03a0: 74 68 65 6e 0a 09 09 64 69 65 20 27 67 6c 69 62  then...die 'glib
03b0: 63 20 64 69 72 65 63 74 6f 72 79 20 69 73 20 6e  c directory is n
03c0: 6f 74 20 61 76 61 69 6c 61 62 6c 65 20 28 61 70  ot available (ap
03d0: 70 66 73 20 72 75 6e 6e 69 6e 67 2f 77 6f 72 6b  pfs running/work
03e0: 69 6e 67 3f 29 27 0a 09 66 69 0a 0a 09 43 46 4c  ing?)'..fi...CFL
03f0: 41 47 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69  AGS="-I${glibcdi
0400: 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 43 50 50  r}/include"..CPP
0410: 46 4c 41 47 53 3d 22 2d 49 24 7b 67 6c 69 62 63  FLAGS="-I${glibc
0420: 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 4c  dir}/include"..L
0430: 44 46 4c 41 47 53 3d 22 2d 57 6c 2c 2d 2d 72 70  DFLAGS="-Wl,--rp
0440: 61 74 68 2c 24 7b 67 6c 69 62 63 64 69 72 7d 2f  ath,${glibcdir}/
0450: 6c 69 62 20 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69  lib -Wl,--dynami
0460: 63 2d 6c 69 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69  c-linker,${dynli
0470: 6e 6b 65 72 7d 22 0a 09 65 78 70 6f 72 74 20 43  nker}"..export C
0480: 46 4c 41 47 53 20 43 50 50 46 4c 41 47 53 20 4c  FLAGS CPPFLAGS L
0490: 44 46 4c 41 47 53 0a 0a 09 2e 2f 63 6f 6e 66 69  DFLAGS..../confi
04a0: 67 75 72 65 20 2d 2d 70 72 65 66 69 78 3d 22 24  gure --prefix="$
04b0: 7b 70 72 65 66 69 78 7d 22 20 2d 2d 73 79 73 63  {prefix}" --sysc
04c0: 6f 6e 66 64 69 72 3d 2f 65 74 63 20 2d 2d 6c 6f  onfdir=/etc --lo
04d0: 63 61 6c 73 74 61 74 65 64 69 72 3d 2f 76 61 72  calstatedir=/var
04e0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65  .}..function pre
04f0: 62 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a  build() {..:.}..
0500: 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74 62 75 69  function postbui
0510: 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e  ld() {..:.}..fun
0520: 63 74 69 6f 6e 20 62 75 69 6c 64 28 29 20 7b 0a  ction build() {.
0530: 09 67 72 65 70 20 22 44 45 53 54 44 49 52 22 20  .grep "DESTDIR" 
0540: 4d 61 6b 65 66 69 6c 65 20 3e 2f 64 65 76 2f 6e  Makefile >/dev/n
0550: 75 6c 6c 20 7c 7c 20 64 69 65 20 22 44 6f 6e 27  ull || die "Don'
0560: 74 20 6b 6e 6f 77 20 68 6f 77 20 74 6f 20 62 75  t know how to bu
0570: 69 6c 64 20 74 68 69 73 20 73 6f 66 74 77 61 72  ild this softwar
0580: 65 22 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a 66 75 6e  e"...make.}..fun
0590: 63 74 69 6f 6e 20 70 72 65 69 6e 73 74 61 6c 6c  ction preinstall
05a0: 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74  () {..:.}..funct
05b0: 69 6f 6e 20 70 6f 73 74 69 6e 73 74 61 6c 6c 28  ion postinstall(
05c0: 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69  ) {..:.}..functi
05d0: 6f 6e 20 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09  on install() {..
05e0: 6d 61 6b 65 20 69 6e 73 74 61 6c 6c 20 44 45 53  make install DES
05f0: 54 44 49 52 3d 22 24 7b 64 65 73 74 64 69 72 7d  TDIR="${destdir}
0600: 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6c  ".}..function cl
0610: 65 61 6e 75 70 28 29 20 7b 0a 09 63 64 20 22 24  eanup() {..cd "$
0620: 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78  {workdir}" || ex
0630: 69 74 20 31 0a 09 63 64 20 2e 2e 20 7c 7c 20 65  it 1..cd .. || e
0640: 78 69 74 20 31 0a 09 72 6d 20 2d 72 66 20 22 24  xit 1..rm -rf "$
0650: 7b 77 6f 72 6b 64 69 72 7d 22 0a 7d 0a 0a 66 75  {workdir}".}..fu
0660: 6e 63 74 69 6f 6e 20 64 69 65 28 29 20 7b 0a 09  nction die() {..
0670: 6c 6f 63 61 6c 20 6d 65 73 73 61 67 65 0a 0a 09  local message...
0680: 6d 65 73 73 61 67 65 3d 22 24 31 22 0a 0a 09 69  message="$1"...i
0690: 66 20 5b 20 2d 6e 20 22 24 7b 6d 65 73 73 61 67  f [ -n "${messag
06a0: 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63  e}" ]; then...ec
06b0: 68 6f 20 22 65 72 72 6f 72 3a 20 24 7b 6d 65 73  ho "error: ${mes
06c0: 73 61 67 65 7d 22 20 3e 26 32 0a 09 66 69 0a 0a  sage}" >&2..fi..
06d0: 09 63 6c 65 61 6e 75 70 0a 0a 09 65 78 69 74 20  .cleanup...exit 
06e0: 31 0a 7d 0a 0a 73 63 72 69 70 74 64 69 72 3d 22  1.}..scriptdir="
06f0: 24 28 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20  $(cd "$(dirname 
0700: 22 24 28 77 68 69 63 68 20 22 24 30 22 29 22 29  "$(which "$0")")
0710: 22 20 26 26 20 70 77 64 29 22 0a 69 66 20 5b 20  " && pwd)".if [ 
0720: 2d 7a 20 22 24 7b 73 63 72 69 70 74 64 69 72 7d  -z "${scriptdir}
0730: 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20  " ]; then..echo 
0740: 22 55 6e 61 62 6c 65 20 74 6f 20 6c 6f 63 61 74  "Unable to locat
0750: 65 20 73 63 72 69 70 74 20 64 69 72 65 63 74 6f  e script directo
0760: 72 79 22 20 3e 26 32 0a 0a 09 65 78 69 74 20 31  ry" >&2...exit 1
0770: 0a 66 69 0a 0a 63 64 20 22 24 7b 73 63 72 69 70  .fi..cd "${scrip
0780: 74 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31  tdir}" || exit 1
0790: 0a 0a 69 66 20 5b 20 2d 66 20 27 62 75 69 6c 64  ..if [ -f 'build
07a0: 2e 63 6f 6e 66 27 20 5d 3b 20 74 68 65 6e 0a 09  .conf' ]; then..
07b0: 2e 20 27 62 75 69 6c 64 2e 63 6f 6e 66 27 0a 66  . 'build.conf'.f
07c0: 69 0a 0a 69 66 20 5b 20 2d 64 20 22 70 6b 67 73  i..if [ -d "pkgs
07d0: 2f 24 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e  /${pkg}" ]; then
07e0: 0a 09 70 6b 67 64 69 72 3d 22 70 6b 67 73 2f 24  ..pkgdir="pkgs/$
07f0: 7b 70 6b 67 7d 22 0a 09 70 6b 67 66 69 6c 65 3d  {pkg}"..pkgfile=
0800: 22 24 7b 70 6b 67 64 69 72 7d 2f 69 6e 66 6f 22  "${pkgdir}/info"
0810: 0a 65 6c 73 65 0a 09 70 6b 67 66 69 6c 65 3d 22  .else..pkgfile="
0820: 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b  pkgs/${pkg}"..pk
0830: 67 64 69 72 3d 22 24 7b 70 6b 67 66 69 6c 65 7d  gdir="${pkgfile}
0840: 22 0a 66 69 0a 0a 69 66 20 5b 20 21 20 2d 65 20  ".fi..if [ ! -e 
0850: 22 24 7b 70 6b 67 66 69 6c 65 7d 22 20 5d 3b 20  "${pkgfile}" ]; 
0860: 74 68 65 6e 0a 09 65 63 68 6f 20 22 49 6e 76 61  then..echo "Inva
0870: 6c 69 64 20 70 61 63 6b 61 67 65 2e 22 20 3e 26  lid package." >&
0880: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 70  2...exit 1.fi..p
0890: 6b 67 64 61 74 65 3d 22 24 28 66 6f 72 20 61 72  kgdate="$(for ar
08a0: 74 69 66 61 63 74 20 69 6e 20 24 28 66 69 6e 64  tifact in $(find
08b0: 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74 79   "${pkgdir}" -ty
08c0: 70 65 20 66 20 2d 70 72 69 6e 74 30 20 7c 20 78  pe f -print0 | x
08d0: 61 72 67 73 20 2d 6e 20 31 20 2d 30 20 66 6f 73  args -n 1 -0 fos
08e0: 73 69 6c 20 66 69 6e 66 6f 20 2d 2d 6c 69 6d 69  sil finfo --limi
08f0: 74 20 31 20 2d 2d 77 69 64 74 68 20 30 20 32 3e  t 1 --width 0 2>
0900: 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 67 72 65 70  /dev/null | grep
0910: 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d   '^[0-9][0-9][0-
0920: 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d  9][0-9]-[0-9][0-
0930: 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 20 27 20  9]-[0-9][0-9] ' 
0940: 7c 20 73 65 64 20 27 73 40 5e 5b 5e 20 5d 2a 20  | sed 's@^[^ ]* 
0950: 5c 5b 40 40 3b 73 40 5c 5d 2e 2a 40 40 27 20 7c  \[@@;s@\].*@@' |
0960: 20 73 6f 72 74 20 2d 75 29 3b 20 64 6f 20 66 6f   sort -u); do fo
0970: 73 73 69 6c 20 69 6e 66 6f 20 22 24 7b 61 72 74  ssil info "${art
0980: 69 66 61 63 74 7d 22 20 7c 20 61 77 6b 20 27 2f  ifact}" | awk '/
0990: 5e 75 75 69 64 3a 2f 7b 20 70 72 69 6e 74 20 24  ^uuid:/{ print $
09a0: 33 20 24 34 20 7d 27 20 7c 20 73 65 64 20 27 73  3 $4 }' | sed 's
09b0: 40 5b 2d 3a 5d 40 40 67 3b 73 40 2e 2e 24 40 5c  @[-:]@@g;s@..$@\
09c0: 2e 26 40 27 3b 20 64 6f 6e 65 20 7c 20 73 6f 72  .&@'; done | sor
09d0: 74 20 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e 20 31  t -n | tail -n 1
09e0: 29 22 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 70 6b  )".if [ -z "${pk
09f0: 67 64 61 74 65 7d 22 20 5d 3b 20 74 68 65 6e 0a  gdate}" ]; then.
0a00: 09 70 6b 67 64 61 74 65 3d 22 24 28 66 69 6e 64  .pkgdate="$(find
0a10: 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74 79   "${pkgdir}" -ty
0a20: 70 65 20 66 20 2d 70 72 69 6e 74 66 20 27 25 54  pe f -printf '%T
0a30: 59 25 54 6d 25 54 64 25 54 48 25 54 4d 2e 25 54  Y%Tm%Td%TH%TM.%T
0a40: 53 5c 6e 27 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  S\n' 2>/dev/null
0a50: 20 7c 20 63 75 74 20 2d 66 20 31 2d 32 20 2d 64   | cut -f 1-2 -d
0a60: 20 27 2e 27 20 7c 20 73 6f 72 74 20 2d 6e 20 7c   '.' | sort -n |
0a70: 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 66 69 0a   tail -n 1)".fi.
0a80: 0a 2e 20 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a  .. "${pkgfile}".
0a90: 0a 61 72 63 68 69 76 65 64 69 72 3d 22 24 28 70  .archivedir="$(p
0aa0: 77 64 29 2f 41 52 43 48 49 56 45 22 0a 77 6f 72  wd)/ARCHIVE".wor
0ab0: 6b 64 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 24  kdir="workdir-$$
0ac0: 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f  ${RANDOM}${RANDO
0ad0: 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 22 0a 73 72 63  M}${RANDOM}".src
0ae0: 66 69 6c 65 3d 22 24 7b 61 72 63 68 69 76 65 64  file="${archived
0af0: 69 72 7d 2f 24 7b 70 6b 67 7d 22 0a 6d 6b 64 69  ir}/${pkg}".mkdi
0b00: 72 20 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d  r "${archivedir}
0b10: 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  " >/dev/null 2>/
0b20: 64 65 76 2f 6e 75 6c 6c 0a 6d 6b 64 69 72 20 22  dev/null.mkdir "
0b30: 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65  ${workdir}" || e
0b40: 78 69 74 20 31 0a 63 64 20 22 24 7b 77 6f 72 6b  xit 1.cd "${work
0b50: 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  dir}" || exit 1.
0b60: 77 6f 72 6b 64 69 72 3d 22 24 28 70 77 64 29 22  workdir="$(pwd)"
0b70: 0a 0a 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 73  ..if [ ! -e "${s
0b80: 72 63 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e  rcfile}" ]; then
0b90: 0a 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09 23 23  ..# Download..##
0ba0: 20 43 6c 65 61 6e 75 70 0a 09 72 6d 20 2d 66 20   Cleanup..rm -f 
0bb0: 73 72 63 2e 6e 65 77 20 73 72 63 0a 0a 09 23 23  src.new src...##
0bc0: 20 46 65 74 63 68 20 66 69 6c 65 0a 09 77 67 65   Fetch file..wge
0bd0: 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22 24 7b  t -O src.new "${
0be0: 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  url}" || exit 1.
0bf0: 0a 09 23 23 20 56 65 72 69 66 79 20 73 69 67 6e  ..## Verify sign
0c00: 61 74 75 72 65 0a 09 73 72 63 5f 73 68 61 32 35  ature..src_sha25
0c10: 36 3d 22 24 28 6f 70 65 6e 73 73 6c 20 73 68 61  6="$(openssl sha
0c20: 32 35 36 20 27 73 72 63 2e 6e 65 77 27 20 7c 20  256 'src.new' | 
0c30: 73 65 64 20 27 73 40 5e 2e 2a 3d 20 40 40 27 29  sed 's@^.*= @@')
0c40: 22 0a 09 69 66 20 5b 20 22 24 7b 73 72 63 5f 73  "..if [ "${src_s
0c50: 68 61 32 35 36 7d 22 20 21 3d 20 22 24 7b 73 68  ha256}" != "${sh
0c60: 61 32 35 36 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  a256}" ]; then..
0c70: 09 65 63 68 6f 20 22 53 48 41 32 35 36 20 6d 69  .echo "SHA256 mi
0c80: 73 6d 61 74 63 68 3a 20 20 44 6f 77 6e 6c 6f 61  smatch:  Downloa
0c90: 64 65 64 3a 20 24 7b 73 72 63 5f 73 68 61 32 35  ded: ${src_sha25
0ca0: 36 7d 20 21 3d 20 45 78 70 65 63 74 65 64 3a 20  6} != Expected: 
0cb0: 24 7b 73 68 61 32 35 36 7d 22 20 3e 26 32 0a 0a  ${sha256}" >&2..
0cc0: 09 09 65 78 69 74 20 31 0a 09 66 69 0a 0a 09 23  ..exit 1..fi...#
0cd0: 23 20 4d 6f 76 65 20 66 69 6c 65 20 69 6e 74 6f  # Move file into
0ce0: 20 70 6c 61 63 65 0a 09 6d 76 20 73 72 63 2e 6e   place..mv src.n
0cf0: 65 77 20 22 24 7b 61 72 63 68 69 76 65 64 69 72  ew "${archivedir
0d00: 7d 2f 24 7b 70 6b 67 7d 22 0a 66 69 0a 0a 23 20  }/${pkg}".fi..# 
0d10: 44 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69  Decompress archi
0d20: 76 65 0a 23 23 20 44 65 74 65 72 6d 69 6e 65 20  ve.## Determine 
0d30: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0d40: 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69 6e  case "${url}" in
0d50: 0a 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74 61 72  ..*.tar.xz|*.tar
0d60: 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29 0a 09  .xz'?'*|*.txz)..
0d70: 09 64 65 63 6f 6d 70 72 65 73 73 3d 27 78 7a 27  .decompress='xz'
0d80: 0a 09 09 3b 3b 0a 09 2a 2e 74 61 72 2e 67 7a 7c  ...;;..*.tar.gz|
0d90: 2a 2e 74 61 72 2e 67 7a 27 3f 27 2a 7c 2a 2e 74  *.tar.gz'?'*|*.t
0da0: 67 7a 29 0a 09 09 64 65 63 6f 6d 70 72 65 73 73  gz)...decompress
0db0: 3d 27 67 7a 69 70 27 0a 09 09 3b 3b 0a 09 2a 2e  ='gzip'...;;..*.
0dc0: 74 61 72 2e 62 7a 32 7c 2a 2e 74 61 72 2e 62 7a  tar.bz2|*.tar.bz
0dd0: 32 27 3f 27 2a 7c 2a 2e 74 62 7a 32 29 0a 09 09  2'?'*|*.tbz2)...
0de0: 64 65 63 6f 6d 70 72 65 73 73 3d 27 62 7a 69 70  decompress='bzip
0df0: 32 27 0a 09 09 3b 3b 0a 09 2a 2e 7a 69 70 7c 2a  2'...;;..*.zip|*
0e00: 2e 7a 69 70 27 3f 27 2a 29 0a 09 09 64 65 63 6f  .zip'?'*)...deco
0e10: 6d 70 72 65 73 73 3d 27 75 6e 7a 69 70 27 0a 09  mpress='unzip'..
0e20: 09 3b 3b 0a 09 2a 29 0a 09 09 65 63 68 6f 20 22  .;;..*)...echo "
0e30: 55 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73  Unknown compress
0e40: 69 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72  ion method: ${ur
0e50: 6c 7d 22 20 3e 26 32 0a 0a 09 09 65 78 69 74 20  l}" >&2....exit 
0e60: 31 0a 09 09 3b 3b 0a 65 73 61 63 0a 0a 23 23 20  1...;;.esac..## 
0e70: 44 6f 20 64 65 63 6f 6d 70 72 65 73 73 69 6f 6e  Do decompression
0e80: 0a 63 61 73 65 20 22 24 7b 64 65 63 6f 6d 70 72  .case "${decompr
0e90: 65 73 73 7d 22 20 69 6e 0a 09 75 6e 7a 69 70 29  ess}" in..unzip)
0ea0: 0a 09 09 75 6e 7a 69 70 20 22 24 7b 73 72 63 66  ...unzip "${srcf
0eb0: 69 6c 65 7d 22 20 7c 7c 20 64 69 65 20 27 55 6e  ile}" || die 'Un
0ec0: 61 62 6c 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65  able to uncompre
0ed0: 73 73 20 61 72 63 68 69 76 65 27 0a 09 09 3b 3b  ss archive'...;;
0ee0: 0a 09 2a 29 0a 09 09 22 24 7b 64 65 63 6f 6d 70  ..*)..."${decomp
0ef0: 72 65 73 73 7d 22 20 2d 64 63 20 22 24 7b 73 72  ress}" -dc "${sr
0f00: 63 66 69 6c 65 7d 22 20 7c 20 74 61 72 20 2d 78  cfile}" | tar -x
0f10: 66 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62  f - || die 'Unab
0f20: 6c 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73  le to uncompress
0f30: 20 61 72 63 68 69 76 65 27 0a 09 09 3b 3b 0a 65   archive'...;;.e
0f40: 73 61 63 0a 0a 23 23 20 43 6c 65 61 6e 75 70 20  sac..## Cleanup 
0f50: 73 6f 75 72 63 65 0a 72 6d 20 2d 66 20 73 72 63  source.rm -f src
0f60: 0a 0a 23 20 49 66 20 77 65 20 6a 75 73 74 20 68  ..# If we just h
0f70: 61 76 65 20 6f 6e 65 20 64 69 72 65 63 74 6f 72  ave one director
0f80: 79 2c 20 75 73 65 20 74 68 61 74 20 64 69 72 65  y, use that dire
0f90: 63 74 6f 72 79 0a 64 69 72 3d 22 24 28 65 63 68  ctory.dir="$(ech
0fa0: 6f 20 2a 29 22 0a 69 66 20 5b 20 2d 65 20 22 24  o *)".if [ -e "$
0fb0: 7b 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {dir}" ]; then..
0fc0: 6d 76 20 22 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a  mv "${dir}"/* ..
0fd0: 66 69 0a 0a 23 20 53 74 61 72 74 20 6c 6f 67 67  fi..# Start logg
0fe0: 69 6e 67 0a 73 65 74 20 2d 78 0a 0a 23 20 44 65  ing.set -x..# De
0ff0: 74 65 72 6d 69 6e 65 20 70 72 6f 70 65 72 74 69  termine properti
1000: 65 73 0a 64 65 74 65 72 6d 69 6e 65 50 72 65 66  es.determinePref
1010: 69 78 0a 0a 23 20 53 74 61 72 74 20 74 68 65 20  ix..# Start the 
1020: 62 75 69 6c 64 0a 70 72 65 63 6f 6e 66 69 67 75  build.preconfigu
1030: 72 65 20 7c 7c 20 64 69 65 20 27 70 72 65 63 6f  re || die 'preco
1040: 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a  nfigure failed'.
1050: 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65  configure || die
1060: 20 27 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c   'configure fail
1070: 65 64 27 0a 70 6f 73 74 63 6f 6e 66 69 67 75 72  ed'.postconfigur
1080: 65 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 63 6f  e || die 'postco
1090: 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a  nfigure failed'.
10a0: 0a 70 72 65 62 75 69 6c 64 20 7c 7c 20 64 69 65  .prebuild || die
10b0: 20 27 70 72 65 62 75 69 6c 64 20 66 61 69 6c 65   'prebuild faile
10c0: 64 27 0a 62 75 69 6c 64 20 7c 7c 20 64 69 65 20  d'.build || die 
10d0: 27 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 70  'build failed'.p
10e0: 6f 73 74 62 75 69 6c 64 20 7c 7c 20 64 69 65 20  ostbuild || die 
10f0: 27 70 6f 73 74 62 75 69 6c 64 20 66 61 69 6c 65  'postbuild faile
1100: 64 27 0a 0a 70 72 65 69 6e 73 74 61 6c 6c 20 7c  d'..preinstall |
1110: 7c 20 64 69 65 20 27 70 72 65 69 6e 73 74 61 6c  | die 'preinstal
1120: 6c 20 66 61 69 6c 65 64 27 0a 69 6e 73 74 61 6c  l failed'.instal
1130: 6c 20 7c 7c 20 64 69 65 20 27 69 6e 73 74 61 6c  l || die 'instal
1140: 6c 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 69 6e  l failed'.postin
1150: 73 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 6f  stall || die 'po
1160: 73 74 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64  stinstall failed
1170: 27 0a 0a 28 0a 09 63 61 73 65 20 22 24 7b 74 61  '..(..case "${ta
1180: 72 67 65 74 6d 6f 64 65 7d 22 20 69 6e 0a 09 09  rgetmode}" in...
1190: 69 6e 73 74 61 6c 6c 29 0a 09 09 09 61 70 70 64  install)....appd
11a0: 69 72 3d 22 24 28 61 70 70 66 73 69 6e 73 74 61  ir="$(appfsinsta
11b0: 6c 6c 64 69 72 29 2f 24 7b 70 72 65 66 69 78 73  lldir)/${prefixs
11c0: 75 66 66 69 78 7d 22 0a 09 09 09 6d 6b 64 69 72  uffix}"....mkdir
11d0: 20 2d 70 20 22 24 7b 61 70 70 64 69 72 7d 22 0a   -p "${appdir}".
11e0: 0a 09 09 09 63 64 20 22 24 7b 64 65 73 74 64 69  ....cd "${destdi
11f0: 72 7d 2f 24 7b 70 72 65 66 69 78 7d 22 20 7c 7c  r}/${prefix}" ||
1200: 20 65 78 69 74 20 31 0a 0a 09 09 09 63 70 20 2d   exit 1.....cp -
1210: 72 70 20 2a 20 22 24 7b 61 70 70 64 69 72 7d 22  rp * "${appdir}"
1220: 0a 09 09 09 66 69 6e 64 20 22 24 7b 61 70 70 64  ....find "${appd
1230: 69 72 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78  ir}" -print0 | x
1240: 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74  args -0 touch -t
1250: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09   "${pkgdate}"...
1260: 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d  .find "${appdir}
1270: 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67  " -print0 | xarg
1280: 73 20 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d 74  s -0 touch -m -t
1290: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09   "${pkgdate}"...
12a0: 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d  .find "${appdir}
12b0: 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67  " -print0 | xarg
12c0: 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74  s -0 touch -a -t
12d0: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09   "${pkgdate}"...
12e0: 09 3b 3b 0a 09 09 61 72 63 68 69 76 65 29 0a 09  .;;...archive)..
12f0: 09 09 61 72 63 68 69 76 65 66 69 6c 65 3d 22 24  ..archivefile="$
1300: 7b 73 63 72 69 70 74 64 69 72 7d 2f 24 7b 70 6b  {scriptdir}/${pk
1310: 67 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 2d 24 28  g}-${version}-$(
1320: 65 63 68 6f 20 22 24 7b 70 6b 67 64 61 74 65 7d  echo "${pkgdate}
1330: 22 20 7c 20 73 65 64 20 27 73 40 5c 2e 40 40 67  " | sed 's@\.@@g
1340: 27 29 2d 24 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69  ')-${domain}.cpi
1350: 6f 22 0a 09 09 09 63 64 20 22 24 7b 64 65 73 74  o"....cd "${dest
1360: 64 69 72 7d 2f 24 7b 70 72 65 66 69 78 7d 2f 2e  dir}/${prefix}/.
1370: 2e 2f 2e 2e 2f 2e 2e 22 20 7c 7c 20 65 78 69 74  ./../.." || exit
1380: 20 31 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72   1....find "${pr
1390: 65 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72  efixsuffix}" -pr
13a0: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20  int0 | xargs -0 
13b0: 74 6f 75 63 68 20 2d 74 20 22 24 7b 70 6b 67 64  touch -t "${pkgd
13c0: 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22 24  ate}"....find "$
13d0: 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 20  {prefixsuffix}" 
13e0: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
13f0: 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22  -0 touch -m -t "
1400: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
1410: 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73 75 66  ind "${prefixsuf
1420: 66 69 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20  fix}" -print0 | 
1430: 78 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d  xargs -0 touch -
1440: 61 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65 7d  a -t "${pkgdate}
1450: 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65  "....find "${pre
1460: 66 69 78 73 75 66 66 69 78 7d 22 20 7c 20 73 6f  fixsuffix}" | so
1470: 72 74 20 7c 20 63 70 69 6f 20 2d 2d 6f 77 6e 65  rt | cpio --owne
1480: 72 20 30 3a 30 20 2d 48 20 6e 65 77 63 20 2d 6f  r 0:0 -H newc -o
1490: 20 3e 20 22 24 7b 61 72 63 68 69 76 65 66 69 6c   > "${archivefil
14a0: 65 7d 22 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a  e}"....;;..esac.
14b0: 29 20 7c 7c 20 64 69 65 20 27 66 69 6e 61 6c 20  ) || die 'final 
14c0: 69 6e 73 74 61 6c 6c 61 74 69 6f 6e 20 66 61 69  installation fai
14d0: 6c 65 64 27 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65  led'..cleanup..e
14e0: 78 69 74 20 30 0a                                xit 0.